/*
[]=========================================================================[]

Copyright(C) 2008, Feitian Technologies Co., Ltd.
All rights reserved.
 
FILE:
	ET_API.h
	
DESC:
	ET interface and defines 
		
[]=========================================================================[]
*/

#ifndef  __FT_ET_HEADER_H
#define  __FT_ET_HEADER_H

#ifdef __cplusplus
extern "C" {
#endif

#ifndef ET_STATUS
#define ET_STATUS		unsigned long
#define ET_API			__stdcall

typedef void*	     	ET_HANDLE;
#endif

#define   ET_TYPE_99                  1
#define   ET_TYPE_299                 2
#define   ET_TYPE_99TIME              3

//Return Value Status Definition
#define	  ET_SUCCESS				0x00			//ִгɹ
#define   ET_ACCESS_DENY            0x01			//ʱܾȨ޲
#define   ET_COMMUNICATIONS_ERROR   0x02			//ͨѶûд豸
#define   ET_INVALID_PARAMETER      0x03			//ЧĲ
#define   ET_NOT_SET_PID            0x04			//ûPID
#define   ET_UNIT_NOT_FOUND 	    0x05			//ָ豸ʧ
#define   ET_HARD_ERROR             0x06			//Ӳ
#define   ET_UNKNOWN                0x07			//һԴ
#define	  ET_PIN_ERR_MASK			0x0F			//֤PIN
#define	  ET_PIN_ERR_MAX		    0xFF            //֤PINʣ֤󻹻ET_PIN_ERR_MAXʾPINԶ

//
#define	  ET_KEY_TYPE				0X10			//Կʹ
#define	  ET_LICENSE_TYPE			0X11			//Ȩʹ
#define	  ET_LICENSE_UNINIT			0x12			//ȨԪδãʱȫȨԪδãֻеȨŻᱻ
#define   ET_NO_LICENSE				0x13			//Ȩʧ
#define   ET_UNKNOWN_UPDATE_FILE	0x14			//δ֪ļʽ
#define	  ET_INVALID_DATA_LEN		0x15			//Ƿݳ
#define   ET_NO_TDES_KEY			0x16			//ЧTDESԿ
#define   ET_INVALID_UPDATE_FILE	0x17			//Чļ
#define	  ET_UNSUPPORTED			0x18			//ֵ֧Ĺ
#define	  ET_ADJUST_TIMER			0x19			//ϵͳʱʧ
#define	  ET_KEY_INDEX				0X1A			//Կ
#define	  ET_KEY_ZERO				0X1B			//0ԿΪϵͳר

//
#define ET99_MEMORY_SIZE			1*1024			//ET99С 
#define ET299_MEMORY_SIZE			6*1024			//ET299С 
#define ET99_TIME_MEMORY_SIZE       512             //ET99 timeС 

//õPID
#define CONST_PID                   "FFFFFFFF"


//===============================et99 et299 et99Timeк=============================
//ET (PID, ҵETĿ)
ET_STATUS ET_API	et_FindToken(char* PIDstr, int * pcount);

//ָPIDET (PID, )
ET_STATUS ET_API	et_OpenToken(ET_HANDLE* hHandle, char* PIDstr, int index);

//رET
ET_STATUS ET_API	et_CloseToken(ET_HANDLE hHandle);

//ET
ET_STATUS ET_API	et_Read(ET_HANDLE hHandle,WORD offset,int Len,unsigned char* pucReadBuf);

//дET
ET_STATUS ET_API	et_Write(ET_HANDLE hHandle,WORD offset,int Len,unsigned char* pucWriteBuf);

//PID (Ӻͳ, µPID)
ET_STATUS ET_API	et_GenPID(ET_HANDLE hHandle,int SeedLen,unsigned char* pucSeed, char* pid);

//
ET_STATUS ET_API	et_GenRandom(ET_HANDLE hHandle,unsigned char* pucRandBuf);

//µSoPIN (Ӻͳ, µSoPIN)
ET_STATUS ET_API	et_GenSOPIN(ET_HANDLE hHandle,int SeedLen,unsigned char* pucSeed, char* pucNewSoPIN);

//UserPIN
ET_STATUS ET_API	et_ResetPIN(ET_HANDLE hHandle, char* pucSoPIN);

//Կ (ԭET99ӿ, ֻHMAC-MD5Կ, Կ32ֽ)
ET_STATUS ET_API	et_SetKey(ET_HANDLE hHandle,int Keyid, unsigned char* pucKeyBuf);

//HMAC-MD5 (Կ, ݼ, 16ֽժҪ)
ET_STATUS ET_API	et_HMAC_MD5(ET_HANDLE hHandle,int keyID,int textLen,unsigned char* pucText,unsigned char *digest);

//֤PIN
ET_STATUS ET_API	et_Verify(ET_HANDLE hHandle,int Flags, char* pucPIN);
//define pin Flags
#define ET_VERIFY_USERPIN			0
#define ET_VERIFY_SOPIN				1

//UserPIN (ԭUserPIN, µUserPIN)
ET_STATUS ET_API	et_ChangeUserPIN(ET_HANDLE hHandle, char* pucOldPIN, char* pucNewPIN);

//ðȫ״̬
ET_STATUS ET_API	et_ResetSecurityState(ET_HANDLE hHandle);//Ҫõet_logoff

//Ӳк (ʱ8ֽӲк, ûɸ)
ET_STATUS ET_API	et_GetSN(ET_HANDLE hHandle,unsigned char* pucSN/*8bytes*/);

//ET2999 (SoPINԴ, UserPINԴ, USERPINֻ)
ET_STATUS ET_API	et_SetupToken(ET_HANDLE hHandle,BYTE bSoPINRetries,BYTE bUserPINRetries,BYTE bUserReadOnly,BYTE bBack);
#define ET_USER_WRITE_READ				0	//д
#define ET_USER_READ_ONLY				1	//ֻ

//ETָʾ
ET_STATUS ET_API	et_TurnOnLED(ET_HANDLE hHandle);

//رETָʾ
ET_STATUS ET_API	et_TurnOffLED(ET_HANDLE hHandle);

// ʵ
ET_STATUS ET_API
MD5_HMAC(unsigned char * pucText,        // pointer to data stream        
		 unsigned long   ulText_Len,     // length of data stream         
		 unsigned char * pucKey,         // pointer to authentication key 
		 unsigned long   ulKey_Len,      // length of authentication key  
		 unsigned char * pucToenKey,     // inner hashed key and  outer hashed key 
		 unsigned char * pucDigest );    // caller digest to be filled in 


//===============================et299 רк=============================
//Կ (et299ר: չԭET99ӿ,TDESԿ,3DESԿ16ֽ)
ET_STATUS ET_API	et_SetKeyEx(ET_HANDLE hHandle,int keyType,int Keyid, unsigned char* keyBuf);
//ѡԿ
#define ET_KEY_HMAC_MD5			0	//ѡHMAC-MD5Կ	
#define ET_KEY_TDES				1	//ѡ3DESԿ

//ȡԶӲк
ET_STATUS ET_API	et_GetSNEx(ET_HANDLE hHandle, unsigned char* pucSN, int* len);

//ԶӲк
ET_STATUS ET_API	et_SetSNEx(ET_HANDLE hHandle,unsigned char* pucSNEx, int len);

//RSAԿ (e=65537 , RSAԿֻڴʱ, κʱ޷ȡ)
ET_STATUS ET_API	et_RSAGenKey(ET_HANDLE hHandle, int keyLen, unsigned char* pBufferRSA_N, unsigned char* pBufferRSA_D);
#define RSA_KEY_LEN_1024	1024	//RSA ԿΪ1024λ
	
//RSAԿԣRSA
ET_STATUS ET_API	et_RSASetKey(ET_HANDLE hHandle, int keyLen, unsigned char* pBufferRSA_N, unsigned char* pBufferRSA_D);

//ԶרRSAԿԣԶ
ET_STATUS ET_API	et_RSASetUpdateKey(ET_HANDLE hHandle, int keyLen, unsigned char* pBufferRSA_N, unsigned char* pBufferRSA_D);

#define ET_RSA_PKCS1_PADDING	1	//PKCS#1䷽ʽ
#define ET_RSA_NO_PADDING		2	//

//RSAԿ
ET_STATUS ET_API	et_RSAPublicEncrypt(ET_HANDLE hHandle, unsigned char* buffer, int* len, int nFillMode);

//RSAԿ
ET_STATUS ET_API	et_RSAPublicDecrypt(ET_HANDLE hHandle, unsigned char* buffer, int* len, int nFillMode);

//RSA˽Կ
ET_STATUS ET_API    et_RSAPrivateEncrypt(ET_HANDLE hHandle, unsigned char* buffer, int* len, int nFillMode);

//RSA˽Կ
ET_STATUS ET_API	et_RSAPrivateDecrypt(ET_HANDLE hHandle, unsigned char* buffer, int* len, int nFillMode);

//3DES
ET_STATUS ET_API	et_TDesEncrypt(ET_HANDLE hHandle, int keyIndex, unsigned char* buffer, int len);

//3DES
ET_STATUS ET_API	et_TDesDecrypt(ET_HANDLE hHandle, int keyIndex, unsigned char* buffer, int len);

//ʱȨ
ET_STATUS ET_API	et_SetTimeLicense(ET_HANDLE hHandle, int unitIndex, int timeMode, unsigned char* newTime);
#define ET_EXPIRE_DATE		0	//ֹȨ
#define ET_TIME_MINUTE		1	//ʱȨ(λ)
#define ET_TIME_DAY			2	//Ȩ(λ)

//ȡʱȨ
ET_STATUS ET_API	et_GetTimeLicense(ET_HANDLE hHandle, int unitIndex, int* timeMode, unsigned char* newTime);

//ʱȨ
ET_STATUS ET_API	et_StartTimeUnit (ET_HANDLE hHandle, int unitIndex);

//ʱȨ
ET_STATUS ET_API	et_StopTimeUnit (ET_HANDLE hHandle, int unitIndex);

//ET299ϵͳʱ
ET_STATUS ET_API	et_AdjustTimer(ET_HANDLE hHandle, unsigned char* newTime);

//üƴȨ
ET_STATUS ET_API	et_SetCountLicense(ET_HANDLE hHandle, int unitIndex, int count, BYTE type);

//ȡƴȨ
ET_STATUS ET_API	et_GetCountLicense(ET_HANDLE hHandle, int unitIndex, int* count,BYTE *type);

//ļϷ
ET_STATUS ET_API	et_CheckUpdateFile(ET_HANDLE hHandle, unsigned char* updateBuffer, int len);

//Զ
ET_STATUS ET_API	et_RemoteUpdate (ET_HANDLE hHandle, unsigned char* updateBuffer, int len);

//ȨļԶļ
ET_STATUS ET_API	et_GenRemoteUpdateFile (ET_HANDLE hHandle, unsigned char* updateBuffer, int len);

//ȡET299汾
ET_STATUS ET_API	et_GetVersion (ET_HANDLE hHandle, WORD* version);

//=====================================================================================
//ȡʵʱ
//pYearз(2000-2099)
//pMonthз(1-12)
//pDayз(1-31)
//pHourзСʱ(0-23)
//pMinuteзط(0-59)
//pSecondз(0-59)
ET_STATUS ET_API et_GetRTCTime(ET_HANDLE hHandle, int* pYear, int* pMonth, int* pDay, int* pHour, int* pMinute, int* pSecond);

//趨ʵʱ(ʱʼ,)
//Year   (2000-2099)
//Month  (1-12)
//Day    (1-31)
//Hour   ʱ(0-23)
//Minute (0-59)
//Second (0-59)
ET_STATUS ET_API et_InitRTCTime(ET_HANDLE hHandle, int Year, int Month, int Day, int Hour, int Minute, int Second);

//ȡʱ
//pLimitз:0(ʱ, pYearзصʱ) >0(еСʱ, pYearзصʱ) <0(ʱ,-1)
//pYearзصʱ(2000-2099)
//pMonthзصʱ(1-12)
//pDayзصʱ(1-31)
//pHourзصʱСʱ(0-23)
//pMinuteзصʱ(0-59)
//pSecondзصʱ(0-59)
ET_STATUS ET_API et_GetTimeLimit(ET_HANDLE hHandle, int* pLimit, int* pYear, int* pMonth, int* pDay, int* pHour, int* pMinute, int* pSecond);

//Զʱ
ET_STATUS ET_API et_UpdateTimeLimit(ET_HANDLE hHandle, BYTE* pUpdatePacket);

//
//Limitз:0(ʱ, Yearõʱ) >0(еСʱ, YearȲ) <0(ʱ,-1)
//Year   (2000-2099)
//Month  (1-12)
//Day    (1-31)
//Hour   ʱ(0-23)
//Minute (0-59)
//Second (0-59)
ET_STATUS ET_API et_GenUpdateData(ET_HANDLE hHandle, char* pSN, int Limit, int Year, int Month, int Day, int Hour, int Minute, int Second, BYTE* pOutPacket);

#ifdef __cplusplus 
}
#endif

#endif	//__FT_ET299_HEADER_H